---
- name: Test change fs with partitions
  hosts: all
  become: true
  vars:
    storage_safe_mode: false
    storage_use_partitions: true
    mount_location: '/opt/test1'
    volume_size: '5g'
    fs_type_after: "{{ 'ext3'
      if (ansible_distribution == 'RedHat' and
          ansible_distribution_major_version == '6')
      else 'ext4' }}"
  tags:
    - tests::lvm
  tasks:
    - name: Run the role
      include_role:
        name: linux-system-roles.storage

    - name: Mark tasks to be skipped
      set_fact:
        storage_skip_checks:
          - blivet_available
          - "{{ (lookup('env',
                        'SYSTEM_ROLES_REMOVE_CLOUD_INIT') in ['', 'false']) |
                ternary('packages_installed', '') }}"
          - service_facts

    - name: Get unused disks
      include_tasks: get_unused_disk.yml
      vars:
        min_size: "{{ volume_size }}"
        max_return: 1

    - name: Create an LVM partition with the default file system type
      include_role:
        name: linux-system-roles.storage
      vars:
        storage_pools:
          - name: bar
            disks: "{{ unused_disks }}"
            volumes:
              - name: test1
                size: "{{ volume_size }}"
                mount_point: "{{ mount_location }}"

    - name: Verify role results
      include_tasks: verify-role-results.yml

    - name: Change the LVM partition file system type to {{ fs_type_after }}
      include_role:
        name: linux-system-roles.storage
      vars:
        storage_pools:
          - name: bar
            disks: "{{ unused_disks }}"
            volumes:
              - name: test1
                size: "{{ volume_size }}"
                fs_type: "{{ fs_type_after }}"
                mount_point: "{{ mount_location }}"

    - name: Verify role results
      include_tasks: verify-role-results.yml

    - name: Repeat the previous invocation to verify idempotence
      include_role:
        name: linux-system-roles.storage
      vars:
        storage_pools:
          - name: bar
            disks: "{{ unused_disks }}"
            volumes:
              - name: test1
                size: "{{ volume_size }}"
                fs_type: "{{ fs_type_after }}"
                mount_point: "{{ mount_location }}"

    - name: Verify role results
      include_tasks: verify-role-results.yml

    - name: Clean up
      include_role:
        name: linux-system-roles.storage
      vars:
        storage_pools:
          - name: bar
            disks: "{{ unused_disks }}"
            state: absent
            volumes:
              - name: test1
                size: "{{ volume_size }}"
                fs_type: "{{ fs_type_after }}"
                mount_point: "{{ mount_location }}"
                state: absent

    - name: Verify role results
      include_tasks: verify-role-results.yml
